//
//  FaceAnalyzeResultObject.swift
//  Gengmei
//
//  Created by licong on 2017/3/20.
//  Copyright © 2017年 更美互动信息科技有限公司. All rights reserved.
//

import UIKit
import GMBaseSwift

@objcMembers
class FeatureObject: GMBaseObject {
    var category = ""
    var title = ""
    var content = ""
    var imageUrl = ""
    var y: CGFloat = 0.0
    var x: CGFloat = 0.0
    var tagId: Int = 0
}

//面部特征分析model
@objcMembers
class FaceFeatureObject: GMBaseObject {
    var eye: FeatureObject = FeatureObject()
    var eyebrow: FeatureObject = FeatureObject()
    var chin: FeatureObject = FeatureObject()
    var nose: FeatureObject = FeatureObject()
    var lip: FeatureObject = FeatureObject()
    var contour: FeatureObject = FeatureObject()
}

@objcMembers
class FaceKeyPoint: GMBaseObject {
    var x: Int = 0
    var y: Int = 0
}

@objcMembers
class FaceLandMarkObject: GMBaseObject {
    var leftEyeBottom: FaceKeyPoint?
    var leftEyeCenter: FaceKeyPoint?
    var leftEyeLeftCorner: FaceKeyPoint?
    var leftEyeLowerLeftQuarter: FaceKeyPoint?
    var leftEyeLowerRightQuarter: FaceKeyPoint?
    var leftEyePupil: FaceKeyPoint?
    var leftEyeRightCorner: FaceKeyPoint?
    var leftEyeTop: FaceKeyPoint?
    var leftEyeUpperLeftQuarter: FaceKeyPoint?
    var leftEyeUpperRightQuarter: FaceKeyPoint?
    var rightEyeBottom: FaceKeyPoint?
    var rightEyeCenter: FaceKeyPoint?
    var rightEyeLeftCorner: FaceKeyPoint?
    var rightEyeLowerLeftQuarter: FaceKeyPoint?
    var rightEyeLowerRightQuarter: FaceKeyPoint?
    var rightEyePupil: FaceKeyPoint?
    var rightEyeRightCorner: FaceKeyPoint?
    var rightEyeTop: FaceKeyPoint?
    var rightEyeUpperLeftQuarter: FaceKeyPoint?
    var rightEyeUpperRightQuarter: FaceKeyPoint?
}

@objcMembers
class FaceAnalyzeResultObject: GMBaseObject {
    var createdTime = ""
    var faceAnalyzed: FaceFeatureObject = FaceFeatureObject()
    var valid = false
    var lastModified = ""
    var shareData = ShareObject()
    var simulatedShareData = ShareObject()
    var imageUrl = ""
    var eyelidSimulated = false         //是否模拟过双眼皮
    var simulatedImageUrl = ""           //模拟整形后的图片
    var simulatedText = ""               //模拟整形后的描述
    var token = ""                      //面部分析token
    var tagId = 0                       //双眼皮的项目id
    var cityTagId = ""                  //双眼皮的城市id
    var landmark = FaceLandMarkObject()
}

